<template>
    <div>
        <el-row>
            <el-col :span="14" :offset="4"> <hr> </el-col>
        </el-row>
        <el-row :gutter="20" style="margin: 2rem 0 1rem">
            <el-col :span="2" :offset="4"><strong>Cuota</strong></el-col>
            <el-col :span="5"><strong>Fecha de vencimiento</strong></el-col>
            <el-col :span="5"><strong>Importe</strong></el-col>
        </el-row>
        <el-row :gutter="20" style="margin:1rem 0"
            v-for="(item, index) in contractFees"
            :key="index">
            <el-col :span="2" :offset="4">
                <p :class="className">{{item.id}}</p>
            </el-col>
            <el-col :span="5">
                <input 
                    class="box__input" 
                    type="date"
                    data-date-format="YYYY-MMMM-DD"
                    v-model="item.dueDate"
                    @input="changeDueDate(index)"
                    @blur="leaveWrite(index)"
                    :min="yesterDate" 
                    ref="date"/>
            </el-col>
            <el-col :span="5">
                <input
                    class="box__input"
                    v-model="item.amount"
                    @input="changeAmount(index, item.amount)"
                    @keyup.enter="calculateAmountOfFees"
                    @keypress="isNumber" size="small"
                    />
            </el-col>
            <el-col :span="1">
                <i 
                    @click="addContractFee(index)" 
                    class="el-icon-circle-plus text-orange" 
                    style="font-size:25px;">
                </i>
            </el-col>
            <el-col :span="1">
                <i 
                    @click="removeContractFee(index)" 
                    class="el-icon-remove" 
                    style="font-size:25px; color: rgb(130, 130, 130)">
                </i>
            </el-col>
        </el-row>
        <el-row :gutter="20">
            <el-col :span="5" :offset="11"> <hr> </el-col>
        </el-row>
    </div>
</template>

<script>
export default {
    name: "QuotasComponent",
    props: {
        contractFees: {
            type: Array
        },
        className: {
            type: String
        },
        addContractFee: {
            type: Function
        },
        removeContractFee: {
            type: Function
        },
        calculateAmountOfFees: {
            type: Function
        },
        isNumber: {
            type: Function
        }
    },
    methods: {
        changeDueDate(index) {
            if(this.contractFees[index].dueDate < this.yesterDate) {
                this.contractFees[index].dueDate = null
            }
            this.$emit('changeInformation')
        },
        changeAmount(index, val) {
            this.$emit('changeInformation')
        },
        leaveWrite(index) {
            if(this.$refs.date[index].value < this.yesterDate) {
                this.$refs.date[index].value = null
            }
        }
    },
    computed: {
        yesterDate() {
            const date = new Date()
            let dateTransform =  date.setTime(date.getTime() - 1800 * 1000 * 24)
            let dateTransformSecond = new Date(dateTransform ).toISOString().split('T')[0]
            return dateTransformSecond
        }
    }
}
</script>
<style lang="css">
    .box__input {
        width: 100% !important;
        min-height: 38px !important;
        border-radius: 4px !important;
        border: 1px solid #c0c4cc !important;
        text-align: center !important;
        box-sizing: border-box;
        padding: 0 15px;
    }
</style>